{  Kniznica TOPLIST

  Pouzitie:
  ---------
  1. zobrazi sa
      TopListForm.ShowModal;

  2. vlozenie do toplistu
      TopListForm.Pridaj(lblMeno.Caption,zabka.body);

  3. vytvorenie 'toplist.dat'
      TopListForm.Vytvor;
}
unit Toplist;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids;

type
  TTopPlayer = record
    meno: string[30];
    body: integer;
  end;

  PZoznam = ^TZoznam;
  TZoznam = record
    data: TTopPlayer;
    next: PZoznam;
  end;

  TTopListForm = class(TForm)
    gridToplist: TStringGrid;
    lblNadpis: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure Nacitaj;
    procedure Uloz;
    procedure Vypln;
    procedure Pridaj(meno: string; body: integer);
    procedure Vytvor;
    procedure Zrus;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TopListForm: TTopListForm;
  zoznam: PZoznam;

implementation

{$R *.dfm}

// vytvorenie gridu
procedure TTopListForm.FormShow(Sender: TObject);
var
  i: integer;
  myRect: TGridRect;
begin
  gridToplist.Cells[1,0]:='Meno hra';
  gridToplist.Cells[2,0]:='Zskan body';
  for i:=1 to 15 do
    gridToplist.Cells[0,i]:=IntToStr(i);
  myRect.Left := 4;
  myRect.Top := 4;
  myRect.Right := 4;
  myRect.Bottom := 4;
  gridToplist.Selection:=myRect;
  // nacitanie toplistu zo suboru
  Nacitaj;
  //vyplnenie StringGridu
  Vypln;
  // zrusenie spojaku z pamate
  Zrus;
end;

// ulozenie toplistu do suboru
procedure TToplistForm.Uloz;
var
  subor: file of TTopPlayer;
begin
  // otvorenie suboru a praca s nim
  AssignFile(subor,'toplist.dat');
  try
    Rewrite(subor);
    try
      while zoznam<>NIL do
        begin
          write(subor,zoznam^.data);
          zoznam:=zoznam.next;
        end;
    finally
      CloseFile(subor);
    end;
  except
    on E:EInOutError do
      case E.ErrorCode of
        2:   ShowMessage('Sbor "toplist.dat" nenjden!');
        103: ShowMessage('Sbor "toplist.dat" sa nepodarilo otvori!');
      else
        ShowMessage('Chyba pri praci zo sborom "toplist.dat"! ('+E.Message+')');
      end;
    end;

end;

// nacitanie toplistu zo suboru
procedure TTopListForm.Nacitaj;
var
  subor: file of TTopPlayer;
  hrac: TTopPlayer;
  pom: PZoznam;
begin
  // inicializacia
  pom:=NIL;
  zoznam:=NIL;
  // otvorenie suboru a praca s nim
  AssignFile(subor,'toplist.dat');
  try
    Reset(subor);
    try
      while not Eof(subor) do
        begin
          read(subor,hrac);
          // vlocenie hraca do spojoveho zoznamu
          if zoznam=NIL then
            begin
              zoznam:=new(PZoznam);
              pom:=zoznam;
              zoznam^.data:=hrac;
              zoznam^.next:=NIL;
            end
          else
            begin
              new(pom.next);
              pom:=pom.next;
              pom.data:=hrac;
              pom.next:=NIL;
            end;
        end;
    finally
      CloseFile(subor);
    end;
  except
    on E:EInOutError do
      case E.ErrorCode of
        2:   begin
               ShowMessage('Sbor "toplist.dat" nenjden!');
               Vytvor;
               Nacitaj;
             end;
        103:  ShowMessage('Sbor "toplist.dat" sa nepodarilo otvori!');
      else
        ShowMessage('Chyba pri praci zo sborom "toplist.dat"! ('+E.Message+')');
      end;
    end;

end;

// procedura na vyplneneie StringGridu
procedure TTopListForm.Vypln;
var
  p: PZoznam;
  i: integer;
begin
  p:=zoznam;
  for i:=1 to 15 do
    begin
      gridToplist.Cells[1,i]:=p^.data.meno;
      gridToplist.Cells[2,i]:=IntToStr(p^.data.body);
      p:=p^.next;
    end;
end;

procedure TTopListForm.Pridaj(meno: string; body: integer);
var
  p,q,pom: PZoznam;
  meno30: string[30];
begin
  // nacitanie spojaku zo suboru
  Nacitaj;
  // inicializacia
  q:=NIL; // predchodca
  p:=zoznam; // aktualny prvok
  // vyhladanie pozicie v zozname najlepsich hracov
  while body<p^.data.body do
    begin
      q:=p;
      p:=p^.next;
      // ked dorazime na koniec zoznamu, nieje v topliste
      if p=NIL then
        exit;
    end;
  // ked sa uzivatel dostal do toplistu, tak okontrolujeme meno (a skratime)
  meno30:=InputBox('Zadanie mena','Zadajte prosm Vae meno:',meno);
  // vytvorenie noveho prvku
  pom:=new(PZoznam);
  pom^.data.meno:=meno30;
  pom^.data.body:=body;
  // zaclenenie do spojaku
  pom^.next:=p;
  if q=NIL then
    zoznam:=pom
  else
    q^.next:=pom;
  // vymazanie posledneho prvku spojaku (15 zaznamov)
  while p<>NIL do
    begin
      q:=p;
      p:=p^.next;
      // ked dorazime na koniec zoznamu, zmazeme posledny prvok
      if p^.next=NIL then
        begin
          q^.next:=NIL;
          dispose(p);
          p:=NIL;
        end;
    end;
  // znovu vyplnime StringGrid
  Vypln;
  // ulozime vysledok
  Uloz;
  // ukazeme okno s toplistom
  ShowModal;
end;

// vytvorenie suboru 'toplist.dat'
procedure TTopListForm.Vytvor;
var
  pom: PZoznam;
  hrac: TTopPlayer;
  i: integer;
begin
  // keby sme chceli zoznam nahodou prepisat
  if zoznam<>NIL then
    begin
      ShowMessage('Zoznam uz existuje, teda sa uz neda vytvorit!');
      Exit;
    end;

  pom:=NIL;

  hrac.meno:='<prazdne>';

  for i:=15 downto 1 do
    begin
      hrac.body:=10*i;

    if zoznam=NIL then
      begin
        zoznam:=new(PZoznam);
        pom:=zoznam;
        zoznam^.data:=hrac;
        zoznam^.next:=NIL;
      end
    else
      begin
        new(pom.next);
        pom:=pom.next;
        pom.data:=hrac;
        pom.next:=NIL;
      end;
  end;
  Uloz;
  Zrus;
end;

// zrusenie spojaku z pamate
procedure TTopListForm.Zrus;
var
  p: PZoznam;
begin
  while zoznam<>NIL do
    begin
      p:=zoznam;
      zoznam:=zoznam^.next;
      dispose(p);
    end;
end;

// vypnutie toplistu pri stlaceni ESC
procedure TTopListForm.FormKeyUp(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key=27) then Close;
end;

end.
