unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, ComCtrls, Menus, Toplist, About, Pomoc;

type
  { objekt   ZABA
    -------------}
  TZaba = class(TObject)
  private
    x,y: Integer;
    smer, faza: Integer;
    zamok: boolean;
    zivoty: integer;
    body: integer;
  public
    constructor Create;
  published
    procedure PridajBody(pocet: integer);
    procedure PridajZivot;
    procedure Kresli;
    procedure Zmaz;
    procedure Pohyb(kam: integer);
    procedure Reset(zomrela: boolean);
  end;

  { objekt   MUCHA
    --------------}
  TMucha = class(TObject)
  private
    x,y: Integer;
    smer, faza: Integer;
  public
    constructor Create;
  published
    procedure Kresli;
    procedure Zmaz;
    procedure RobNieco;
    procedure Pohyb(kam: integer; cely: boolean);
    procedure Reset;
  end;

  { objekt  LIST
    ------------ }
  TList = class(TObject)
  private
    // pozicia
    x,y: Integer;
    // aka je velikost
    stav: Shortint;
    // co je na liste
    zataz: integer;
  public
    constructor Create(ix,iy: Shortint);
    procedure Kresli;
    procedure Reset;
    procedure Zmensi;
    function Existuje: Boolean;
  published
    { Published declarations }
  end;

  { objekt  formulara
    ----------------- }
  TForm1 = class(TForm)
    lblNadpisMeno: TLabel;
    lblNadpisBody: TLabel;
    lblNadpisZivoty: TLabel;
    lblMeno: TLabel;
    EditMeno: TEdit;
    btnMeno: TBitBtn;
    lblBody: TLabel;
    MainMenu: TMainMenu;
    Hra: TMenuItem;
    Moznosti: TMenuItem;
    Novahra: TMenuItem;
    Zvuk: TMenuItem;
    Bocpanel: TMenuItem;
    Pomoc: TMenuItem;
    Pomoc2: TMenuItem;
    Info1: TMenuItem;
    Toplist: TMenuItem;
    Koniec: TMenuItem;
    Pauza: TMenuItem;
    Novahra2: TMenuItem;
    Pauza2: TMenuItem;
    Koniec2: TMenuItem;
    Zadatmeno: TMenuItem;
    lblZivoty: TLabel;
    Plocha: TImage;
    Timer1: TTimer;
    procedure Kresli(posX, posY: Integer; Kam: TCanvas; var Co: TBitmap; var Alpha: TBitmap);
    procedure Init(Sender: TObject);
    procedure AppException(Sender: TObject; E: Exception);
    procedure NacitajObrazky;
    procedure InicializujListy;
    procedure ResetujListy;
    procedure VykresliListy;
    procedure ZmensiListy;
    procedure Voda(i: Integer);
    procedure FormCreate(Sender: TObject);
    procedure PlochaRepaint(const Rect: TRect);
    procedure Uvod;
    procedure KoniecClick(Sender: TObject);
    procedure lblNadpisMenoClick(Sender: TObject);
    procedure EditMenoDblClick(Sender: TObject);
    procedure EditMenoKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure BocpanelClick(Sender: TObject);
    procedure ZadatmenoClick(Sender: TObject);
    procedure ZvukClick(Sender: TObject);
    procedure ToplistClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure NovahraClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure KoniecHry;
    procedure PauzaClick(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure Pomoc2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Pozadie(X,Y: Integer); overload;
    procedure Pozadie(X1,Y1,X2,Y2: Integer); overload;
  end;

var
  Form1: TForm1;

implementation

uses Types, Math;
{$R *.dfm}
const
  // pocet listov
  POCET_LISTOV=9;

var
  // premenna obtiaznosti - iba pre testovacie ucely (generovanie listov)
  OBTIAZNOST: integer; // 0=same listy, 10=ziadne listy

  // premenna, ktora urci zachytavanie onKeyDown (sipok)
  hrajem: boolean;

  // obrazky s plochou
  PlochaVoda: TBitmap;
  PlochaListy: TBitmap;

  // premenne obrazkov
  Kolac, KolacM,
  Zivot, ZivotM,
  Zlato,ZlatoM : TBitmap;

  {     0
      2   3          0-sediaca
        1            1-skok }
  Mucha, MuchaM: array [0..3,0..1] of TBitmap;
  Zaba, ZabaM: array [0..3,0..1] of TBitmap;
  // Listy
  List,ListM: array [1..8] of TBitmap;
  Listy : array [0..(POCET_LISTOV-1),0..(POCET_LISTOV-1)] of TList;
  // zive bytosti
  Zabka : TZaba;
  Muska : TMucha;

{ -----------------------------------------
                  TMucha

  ----------------------------------------- }
// konstruktor muchy
constructor TMucha.Create;
begin
  inherited Create;
  Reset;
end;

// vykresli muchu na canvas Plocha: TImage (na formular)
procedure TMucha.Kresli;
begin
  Form1.Kresli(x,y,Form1.Plocha.Canvas,Mucha[smer,faza],MuchaM[smer,faza]);
  Application.ProcessMessages;
end;

// obnovy Plochu z bitmapy PlochaListy
procedure TMucha.Zmaz;
begin
  Form1.PlochaRepaint(Rect(x,y,x+64,y+64));
end;

// resetuje hodnoty
procedure TMucha.Reset;
begin
  //zmazanie starej muchy
  Zmaz;
  x:=8*64;     y:=0;
  smer:=1;  faza:=0;
  // vykreslenie novej
  Kresli;
  Listy[8,8].zataz:=6+3;
end;

// nastavy nove hodnoty, kontroluje poziciu a kresli
procedure TMucha.Pohyb(kam: integer; cely: boolean);
var
  ix,iy: integer;
begin
  // pozrieme kam skaceme
  smer:=kam;
  Zmaz;
  Kresli;
  // ked mame spravit cely skok
  if cely then
    begin
      // vypocitame index listu
      ix:=(x div 64);
      iy:=(8-(y div 64));
      // zrusime zatazenie listu z ktoreho skaceme
      Listy[ix,iy].zataz:=Listy[ix,iy].zataz-3;
      // je uprostred skoku
      Zmaz;
      case kam of
        0: y:=y-32;     //      0
        1: y:=y+32;     //    2   3
        2: x:=x-32;     //      1
        3: x:=x+32;
      end;
      // kontrola vyskocenia
      if ((x<0) or (y<0) or (x>=(8*64+1)) or (y>=(8*64+1))) then
        begin
          // krok spat
          case kam of
            0: y:=y+32;
            1: y:=y-32;
            2: x:=x+32;
            3: x:=x-32;
          end;
          Kresli;
          Listy[ix,iy].zataz:=Listy[ix,iy].zataz+3; // vratime zatazenie
          exit;
        end;

      faza:=1;
      Kresli;
      Sleep(100);
      Zmaz;
      // a je na dalsom liste
      case kam of
        0: y:=y-32;
        1: y:=y+32;
        2: x:=x-32;
        3: x:=x+32;
      end;
      faza:=0;
      Kresli;
      // vypocitame index listu
      ix:=(x div 64);
      iy:=(8-(y div 64));
      // ked list, kam sme skocili neexistuje, tak sa zabka resetuje
      if not Listy[ix,iy].Existuje then
        begin
          Zmaz;
          Reset;
        end
      else
        begin
          // kontrolujeme aktualne zatazenie listu:
          if Listy[ix,iy].zataz=1 then
            begin //zabka
              Zabka.Reset(True);
              Listy[ix,iy].zataz:=0;
              Listy[ix,iy].Kresli;
              Form1.PlochaRepaint(Rect(x,y,x+64,y+64));
              Kresli;
            end;
          Listy[ix,iy].zataz:=Listy[ix,iy].zataz+3;
        end;
    end;
end;

// procedura volana, aby sa mucha nenudila - tato procedura vyvola pohyb
procedure TMucha.RobNieco;
var
  ix,iy,kam: integer;
  cely: boolean;
begin
  // smer 0-3
  kam:=RandomRange(0,4);

  // vypocitame index, kde sme
  ix:=(x div 64);
  iy:=(8-(y div 64));
  // vypocitame, kam skaceme
  case kam of
    0: inc(iy);     //      0
    1: dec(iy);     //    2   3
    2: dec(ix);     //      1
    3: inc(ix);
  end;

  if (ix<9) and (iy<9) and (ix>=0) and (iy>=0) then
    if Listy[ix,iy].Existuje then
      cely:=True
    else
      cely:=False
  else
    cely:=False;

  Pohyb(kam,cely);
end;

{ -----------------------------------------
                  TZaba

  ----------------------------------------- }

// konstruktor Zaby
constructor TZaba.Create;
begin
  inherited Create;
  zivoty:=5;
  body:=0;
  Reset(False);
end;

// vykresli zabu na canvas Plocha: TImage (na formular)
procedure TZaba.Kresli;
begin
  Form1.Kresli(x,y,Form1.Plocha.Canvas,Zaba[smer,faza],ZabaM[smer,faza]);
  Application.ProcessMessages;
end;

// obnovy Plochu z bitmapy PlochaListy
procedure TZaba.Zmaz;
begin
  Form1.PlochaRepaint(Rect(x,y,x+64,y+64));
end;

// nastavy nove hodnoty, kontroluje poziciu a kresli
procedure TZaba.Pohyb(kam: integer);
var
  ix,iy: integer;
begin
  // ked sa uz pohybuje, dalsi pohyb sa nekona {tj. keby dostal spravu, ze bola stlacena klavesa}
  // problem s vyskocenim za obzor, ked sa klavesa drzi a nie macka
  // onKeyDown vola Pohyb priliz rychlo
  if zamok then
    exit
  else
    zamok:=True;

  // zrusime zatazenie listu z ktoreho skaceme
  Listy[(x div 64),(8-(y div 64))].zataz:=0;

  // zabka sa pozrie kam skace
  smer:=kam;
  Zmaz;
  Kresli;
  // je uprostred skoku
  Zmaz;
  case kam of
    0: y:=y-32;     //      0
    1: y:=y+32;     //    2   3      0-sediaca
    2: x:=x-32;     //      1        1-skok
    3: x:=x+32;
  end;
  // kontrola vyskocenia
  if ((x<0) or (y<0) or (x>=(8*64+1)) or (y>=(8*64+1))) then
    begin
      // krok spat
      case kam of
        0: y:=y+32;
        1: y:=y-32;
        2: x:=x+32;
        3: x:=x-32;
      end;
      Kresli;
      Listy[(x div 64),(8-(y div 64))].zataz:=1; // vratime zatazenie
      zamok:=False;
      exit;
    end;

  faza:=1;
  Kresli;
  Sleep(100);
  Zmaz;
  // a je na dalsom liste
  case kam of
    0: y:=y-32;
    1: y:=y+32;
    2: x:=x-32;
    3: x:=x+32;
  end;
  faza:=0;
  Kresli;
  // vypocitame index listu
  ix:=(x div 64);
  iy:=(8-(y div 64));
  // ked list, kam sme skocili neexistuje, tak sa zabka resetuje
  if not Listy[ix,iy].Existuje then
    begin
      Zmaz;
      Reset(True);
    end
  else
    begin
      // pridame bod za skok
      PridajBody(1);
      // kontrolujeme aktualne zatazenie listu:
      case Listy[ix,iy].zataz of
        0:  Listy[ix,iy].zataz:=1;
        2:  begin //kolac
              Listy[ix,iy].zataz:=1;
              Listy[ix,iy].Kresli;
              Form1.PlochaRepaint(Rect(x,y,x+64,y+64));
              Kresli;
              PridajBody(50);
              //Listy[ix,iy].zataz:=1;
            end;
        3, 2+3, 4+3, 6+3: begin //mucha
              Reset(True);
            end;
        4:  begin //zivot
              Listy[ix,iy].zataz:=1;
              Listy[ix,iy].Kresli;
              Form1.PlochaRepaint(Rect(x,y,x+64,y+64));
              Kresli;
              PridajZivot;
            end;
        6:  begin //ciel
              Zmaz;
              Reset(False);
              PridajBody(100);
              Exit;
            end;
      end;
    end;
  zamok:=False;
end;

procedure TZaba.Reset(zomrela: boolean);
var
  ix,iy: integer;
begin
  // zrusime zatazenie listu na ktorom sme zomreli
  ix:=(x div 64);
  iy:=(8-(y div 64));
  if (ix>=0) and (iy>=0) and (ix<9) and (iy<9) then
    if Listy[ix,iy].zataz=1 then
      Listy[ix,iy].zataz:=0;
  //zmazanie starej zaby
  Zmaz;
  // nulovanie
  x:=0;     y:=8*64;
  smer:=0;  faza:=0;
  zamok:=False;
  // zivoty iba ked zomrela
  if zomrela then
    begin
      // uberieme body za smrt
      PridajBody(-5);
      if zivoty=0 then
        // koniec hry
        Form1.KoniecHry
      else
        // uberieme zivot
        begin
          zivoty:=zivoty-1;
          Form1.lblZivoty.Caption:=IntToStr(zivoty);
        end;
    end;
  Kresli;
end;

procedure TZaba.PridajBody(pocet: integer);
begin
  body:=body+pocet;
  Form1.lblBody.Caption:=IntToStr(body);
  // zrychlenie hry pri skonceni jedneho kola alebo zobrati kolaca
  if (Form1.Timer1.Interval>500) then
    if (pocet=100) then
      Form1.Timer1.Interval:=Form1.Timer1.Interval-10
    else if (pocet=50) then
        Form1.Timer1.Interval:=Form1.Timer1.Interval-5;
end;

procedure TZaba.PridajZivot;
begin
  inc(zivoty);
  Form1.lblZivoty.Caption:=IntToStr(zivoty);
end;

{ -----------------------------------------
                  TList

  ----------------------------------------- }

// konstruktor Listu, nastavi poziciu x a y
constructor TList.Create(ix,iy: Shortint);
begin
  inherited Create;
  x:=ix*64;
  y:=(8-iy)*64; // kvoli cislovaniu pola (dole vlavo je 0,0 - hore vpravo je 8,8)
  Reset;
end;

// Reset listu (nastavi sa stav ako v Create)
procedure TList.Reset;
var
  ix,iy: integer;
begin
  // Zmazanie listu z plochy
  Form1.Pozadie(x,y,x+64,y+64);
  ix:=x div 64;
  iy:=8-(y div 64);
  // pri resete na liste nic neni (startovne policko sa nezmensuje,
  // moze mat nulu), ciel ma zataz 6, mucha sa umiestni az neskor
  if (ix=(POCET_LISTOV-1)) and (iy=(POCET_LISTOV-1)) then
    zataz:=6
  else
    zataz:=0;
  // generovanie stavu
  if ((ix=0) and (iy=0)) or ((ix=8) and (iy=8)) then
    stav:=1
  else
    stav:=RandomRange(0,8);
end;

// vykreslenie listu na TImage PlochaListy
procedure TList.Kresli;
begin
  // Zmazanie listu z plochy
  Form1.Pozadie(x,y,x+64,y+64);
  if (stav>0) and (stav<=8) then
    begin
      Form1.Kresli(x+(stav-1)*3,y+(stav-1)*3,PlochaListy.Canvas,List[stav],ListM[stav]);
      case zataz of
        2, 2+3: Form1.Kresli(x,y,PlochaListy.Canvas,Kolac,KolacM); //kolac
        4, 4+3: Form1.Kresli(x,y,PlochaListy.Canvas,Zivot,ZivotM); //zivot
      end;
    end;
end;

// zmensi list
procedure TList.Zmensi;
begin
  if (stav>0) then
    // ked list existuje, tak ho zmensime
    stav:=(stav+1) mod 9
  else
    // ked neexistuje, tak posleme "spravu objektu", ktory je na liste,
    begin
      case zataz of
        1: Zabka.Reset(True); //zaba
        3, 2+3, 4+3: Muska.Reset; //mucha
      end;
      zataz:=0;
      // a list nahodne vytvorime
      if RandomRange(0,10)>OBTIAZNOST then
        begin
          stav:=1;
          if RandomRange(0,100)>97 then zataz:=4; // zivot
          if RandomRange(0,100)<5 then zataz:=2; // kolac
        end;
    end;
  Kresli;
end;

function TList.Existuje: Boolean;
begin
  if stav>0 then
    Result:=True
  else
    Result:=False;
end;

{ -----------------------------------------
                  TForm1

  ----------------------------------------- }

// Vykreslenie bitmapy CO s maskou ALPHA do Image-u KAM na poziciu posX,posY
procedure TForm1.Kresli(posX, posY: Integer; Kam: TCanvas; var Co: TBitmap; var Alpha: TBitmap);
var  x,y: integer;
     i:real;
     Pom: TBitmap;
     PCo, PAlpha, PPom: PByteArray;
begin
  Pom:= TBitmap.Create;
  try
    Pom.LoadFromFile('pictures/blank.bmp');
  except
    ShowMessage('Chyba pri nacitani "blank.bmp"!');
  end;
  Pom.Width:=Co.Width;
  Pom.Height:=Co.Height;
  Pom.Transparent:=False;
  // zobrazenie pozadia z vody
  //Pom.Canvas.CopyRect(Rect(0,0,Co.Width,Co.Height),PlochaVoda.Canvas,Rect(posX,posY,posX+Co.Width,posY+Co.Height));
  // zobranie pozadia z miesta, kam sa kresli (nepouzite)
  Pom.Canvas.CopyRect(Rect(0,0,Co.Width,Co.Height),Kam,Rect(posX,posY,posX+Co.Width,posY+Co.Height));

  for y:=0 to Co.Height-1 do
    begin
      PCo:=Co.ScanLine[y];
      PAlpha:=Alpha.ScanLine[y];
      PPom:=Pom.ScanLine[y];
      for x:=0 to Co.Width-1 do
        begin
          // intenzita z bitmapy s Maskou
          i:= ((PAlpha[3*x])/255.0);
          // jednotlive zlozky (b,g,r)
          PPom[3*x]:=round( i*PCo[3*x] + (1-i)*PPom[3*x] );
          PPom[3*x+1]:=round( i*PCo[3*x+1] + (1-i)*PPom[3*x+1] );
          PPom[3*x+2]:=round( i*PCo[3*x+2] + (1-i)*PPom[3*x+2] );
        end;
    end;
  // zakreslenie objektu Co s alfakanalom Alpha
  Kam.Draw(posX,posY,Pom);
  Pom.Free;
end;

// Nacita obrazky do globalnych premennych
procedure TForm1.NacitajObrazky;
var i,j:integer;
begin
try
// ZABA
for i:=0 to 3 do
  for j:=0 to 1 do
    begin
      Zaba[i,j] := TBitmap.Create;
      Zaba[i,j].LoadFromFile('pictures/zaba/Zaba_'+IntToStr(i)+'_'+IntToStr(j)+'.bmp');
      ZabaM[i,j] := TBitmap.Create;
      ZabaM[i,j].LoadFromFile('pictures/zaba/ZabaM_'+IntToStr(i)+'_'+IntToStr(j)+'.bmp');
    end;
// MUCHA
for i:=0 to 3 do
  for j:=0 to 1 do
    begin
      Mucha[i,j] := TBitmap.Create;
      Mucha[i,j].LoadFromFile('pictures/mucha/Mucha_'+IntToStr(i)+'_'+IntToStr(j)+'.bmp');
      MuchaM[i,j] := TBitmap.Create;
      MuchaM[i,j].LoadFromFile('pictures/mucha/MuchaM_'+IntToStr(i)+'_'+IntToStr(j)+'.bmp');
    end;
// LISTY
for i:=1 to 8 do
  begin
    List[i]:=TBitmap.Create;
    List[i].LoadFromFile('pictures/list/List_'+IntToStr(i)+'.bmp');
    ListM[i]:=TBitmap.Create;
    ListM[i].LoadFromFile('pictures/list/ListM_'+IntToStr(i)+'.bmp');
  end;
// KOLAC
Kolac := TBitmap.Create;
Kolac.LoadFromFile('pictures/kolac.bmp');
KolacM := TBitmap.Create;
KolacM.LoadFromFile('pictures/kolac_m.bmp');
// ZIVOT
Zivot := TBitmap.Create;
Zivot.LoadFromFile('pictures/zivot.bmp');
ZivotM := TBitmap.Create;
ZivotM.LoadFromFile('pictures/zivot_m.bmp');
// ZLATO
Zlato := TBitmap.Create;
Zlato.LoadFromFile('pictures/zlato.bmp');
ZlatoM := TBitmap.Create;
ZlatoM.LoadFromFile('pictures/zlato_m.bmp');
except
  ShowMessage('Chyba pri nacitani obrazkov!');
end;
end;

// Vytvori pole listov (globalna premenna)
procedure TForm1.InicializujListy;
var
  i,j: integer;
begin
  for i:=0 to (POCET_LISTOV-1) do
    for j:=0 to (POCET_LISTOV-1) do
      Listy[i,j]:= TList.Create(i,j);
end;

// Resetuje pole listov
procedure TForm1.ResetujListy;
var
  i,j: integer;
begin
  for i:=0 to (POCET_LISTOV-1) do
    for j:=0 to (POCET_LISTOV-1) do
      Listy[i,j].Reset;
end;

// vykresli toto pole listov podla toho, aky je list
procedure TForm1.VykresliListy;
var
  i,j: integer;
begin
  for i:=0 to (POCET_LISTOV-1) do
    for j:=0 to (POCET_LISTOV-1) do
      Listy[i,j].Kresli;
  // vykreslenie ZLATA
  Form1.Kresli((POCET_LISTOV-1)*64,0,PlochaListy.Canvas,Zlato,ZlatoM);
end;

// zmensi listy
procedure TForm1.ZmensiListy;
var
  i,j: integer;
begin
  for i:=0 to (POCET_LISTOV-1) do
    for j:=0 to (POCET_LISTOV-1) do
      begin
        // bez startovneho a cieloveho policka {pouzije sa pri Timeru}
        if ((i=0) and (j=0)) or ((i=(POCET_LISTOV-1)) and (j=(POCET_LISTOV-1))) then
          {startovne a cielove policko sa nezmensuje}
        else
          Listy[i,j].Zmensi;
      end;
end;

// kresli zadany stvorec z bitmapy s vodou PlochaVoda
procedure TForm1.Pozadie(X1,Y1,X2,Y2: Integer);
begin
  PlochaListy.Canvas.CopyRect(Rect(X1,Y1,X2,Y2),PlochaVoda.Canvas,Rect(X1,Y1,X2,Y2));
end;

// kresli modry stvorec (podla indexu v tabulke 64x64)
procedure TForm1.Pozadie(X,Y: Integer);
begin
  Form1.Pozadie(X*64,Y*64,(X+1)*64,(Y+1)*64);
end;

// Vykreslenie vody
procedure TForm1.Voda(i: Integer);
var
  pom: TBitmap;
  m,n: integer;
begin
  pom:=TBitmap.Create;
{ // v pripade animovania vody (bolo to nejake pomale, tak sa to nekona)
  if (i<10) then
    pom.LoadFromFile('pictures/water/water_00'+IntToStr(i)+'.bmp')
  else
    pom.LoadFromFile('pictures/water/water_0'+IntToStr(i)+'.bmp');
}
  try
    pom.LoadFromFile('pictures/voda_velka.bmp');
  except
    ShowMessage('Chyba pri nacitani obrazku vody!');
  end;
  for m:=0 to 5 do
    for n:=0 to 5 do
      PlochaVoda.Canvas.Draw(m*128,n*128,pom);

  pom.Free;
end;

// inicializacna procedura, vola sa na FormCreate
procedure TForm1.Init(Sender: TObject);
begin
  Randomize;
  DoubleBuffered:=True;
  // Definovanie ploch
    // voda
    PlochaVoda:=TBitmap.Create;
    PlochaVoda.Height:=576;
    PlochaVoda.Width:=576;
    PlochaVoda.Transparent:=False;
    // listy
    PlochaListy:=TBitmap.Create;
    PlochaListy.Height:=576;
    PlochaListy.Width:=576;
    PlochaListy.Transparent:=False;
  // Vykreslenie vody do bitmapy s vodou
  Voda(1);
  // Zakreslenie vody do bitmapy s listami (inak kresli stvorec (ako pozadie z vody))
  Form1.Pozadie(0,0,576,576);
  // nacitanie obrazkov do premennych
  Form1.NacitajObrazky;
  // vytvori listy
  Form1.InicializujListy;
  // defaultne vypne pytanie mena a bocny panel
  BocpanelClick(Sender);
  // uvodne privytanie a info
  Uvod;
  // urcenie pociatocnej obtiaznosti (objavovanie listov)
  OBTIAZNOST:=4;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Zabka:=NIL;
  Muska:=NIL;
  zoznam:=NIL;
  Application.OnException:=AppException;
  Form1.Init(Sender);
end;

// ukaze chybovu hlasku pri vynimke
procedure TForm1.AppException(Sender: TObject; E: Exception);
begin
  Application.ShowException(E);
end;

// prekreslenie plochy z bitmapy PlochaListy
procedure TForm1.PlochaRepaint(const Rect: TRect);
begin
  Plocha.Canvas.CopyRect(Rect,PlochaListy.Canvas,Rect);
end;

procedure TForm1.Uvod;
begin
  Plocha.Canvas.CopyRect(Rect(0,0,576,576),PlochaVoda.Canvas,Rect(0,0,576,576));
  // styl pisma
  Plocha.Canvas.Brush.Style := bsClear;
  Plocha.Canvas.Font.Name := 'Arial';
  Plocha.Canvas.Font.Size := 72;
  Plocha.Canvas.Font.Style:= [ fsBold ];
  // meno
  Plocha.Canvas.Font.Color := clBlack;
  Plocha.Canvas.TextOut( 31,31,'Perestrojka' );
  Plocha.Canvas.Font.Color := clWhite;
  Plocha.Canvas.TextOut( 29,29,'Perestrojka' );
  Plocha.Canvas.Font.Color := $04d8ff;//clYellow;
  Plocha.Canvas.TextOut( 30,30,'Perestrojka' );
  // styl pisma
  Plocha.Canvas.Font.Size := 20;
  // Autor
  Plocha.Canvas.Font.Color := clBlack;
  Plocha.Canvas.TextOut( 151,151,'2005  Tom Petrek' );
  Plocha.Canvas.Font.Color := clWhite;
  Plocha.Canvas.TextOut( 149,149,'2005  Tom Petrek' );
  Plocha.Canvas.Font.Color := $00ba67;
  Plocha.Canvas.TextOut( 150,150,'2005  Tom Petrek' );
  // styl pisma
  Plocha.Canvas.Font.Size := 20;
  // info
  Plocha.Canvas.Font.Color := clNavy;
  Plocha.Canvas.TextOut( 200,250,'F1   Npoveda' );
  Plocha.Canvas.TextOut( 200,280,'F2   Nov hra' );
  Plocha.Canvas.TextOut( 200,310,'F9   Toplist' );
  Plocha.Canvas.TextOut( 200,340,'F10 Koniec' );
end;

procedure TForm1.KoniecClick(Sender: TObject);
begin
  Close;
end;

// Zadanie mena kliknutim na popisku alebo meno (zapnuty bocny panel)
procedure TForm1.lblNadpisMenoClick(Sender: TObject);
begin
  lblMeno.Hide;
  EditMeno.Show;
  EditMeno.Text:=lblMeno.Caption;
  EditMeno.SetFocus;
  btnMeno.Show;
end;

// Pri dvojitom kliknuti na zadavane meno sa ulozi (ako enter)
procedure TForm1.EditMenoDblClick(Sender: TObject);
begin
  EditMeno.Hide;
  btnMeno.Hide;
  lblMeno.Show;
  lblMeno.Caption:=EditMeno.Text;
end;

// pri ESC sa zrusi zadavanie, obnovi sa povodne meno
procedure TForm1.EditMenoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = 27) then
    begin
      EditMeno.Hide;
      btnMeno.Hide;
      lblMeno.Show;
    end;
end;

// vypnutie alebo zapnutie bocneho panelu
// je tam alebo bocny panel, alebo na spodku body&zivoty
procedure TForm1.BocpanelClick(Sender: TObject);
var
  vyska: integer;
begin
  if Bocpanel.Checked then
    begin
      if (Zadatmeno.Checked and (lblMeno.Caption='')) then
        Zadatmeno.Checked:=False;

      lblNadpisBody.Top :=580;
      lblNadpisBody.Left:=5;
      lblBody.Top:=580;
      lblBody.Left:=55;

      lblNadpisZivoty.Top :=580;
      lblNadpisZivoty.Left:=480;
      lblZivoty.Top :=580;
      lblZivoty.Left:=540;

      lblNadpisMeno.Hide;
      lblMeno.Hide;
      EditMeno.Hide;
      btnMeno.Hide;
    end
  else
    begin
      if Zadatmeno.Checked then
        begin
          vyska:=0;
          lblNadpisMeno.Show;
          lblMeno.Show;
        end
      else
        begin
          vyska:=56;
          lblNadpisMeno.Hide;
          lblMeno.Hide;
          EditMeno.Hide;
          btnMeno.Hide;
        end;

      lblNadpisBody.Top:=56-vyska;
      lblNadpisBody.Left:=592;
      lblBody.Top:=80-vyska;
      lblBody.Left:=600;

      lblNadpisZivoty.Top :=112-vyska;
      lblNadpisZivoty.Left:=592;
      lblZivoty.Top :=136-vyska;
      lblZivoty.Left:=600;
    end;

  Bocpanel.Checked:=not Bocpanel.Checked;
end;

// zadavanie mena, ked je bocny panel, zadava sa zobrazenim (alebo sa vypne),
// ked je vypnuty boc. panel, tak sa len opyta na meno, neda sa vypnut
// toto meno sa potom pouzije pri zapisani do toplistu
procedure TForm1.ZadatmenoClick(Sender: TObject);
begin
  // ked je vypnuty bocny panel, tak si meno iba vypytame
  if (not Bocpanel.Checked) then
    begin
      lblMeno.Caption:=InputBox('Zadanie mena','Zadajte prosm svoje meno:',lblMeno.Caption);
      Zadatmeno.Checked:=True;
    end
  else
    begin
      Zadatmeno.Checked:=not Zadatmeno.Checked;
      if Zadatmeno.Checked then
        begin
          lblNadpisBody.Top:=56;
          lblNadpisBody.Left:=592;
          lblBody.Top:=80;
          lblBody.Left:=600;

          lblNadpisZivoty.Top :=112;
          lblNadpisZivoty.Left:=592;
          lblZivoty.Top :=136;
          lblZivoty.Left:=600;

          lblNadpisMeno.Show;
          lblMeno.Show;

          lblNadpisMenoClick(Sender);
        end
      else
        begin
          lblNadpisMeno.Hide;
          lblMeno.Hide;
          EditMeno.Hide;
          btnMeno.Hide;

          lblNadpisBody.Top:=0;
          lblNadpisBody.Left:=592;
          lblBody.Top:=24;
          lblBody.Left:=600;

          lblNadpisZivoty.Top :=56;
          lblNadpisZivoty.Left:=592;
          lblZivoty.Top :=80;
          lblZivoty.Left:=600;
        end;
    end;
end;

procedure TForm1.ZvukClick(Sender: TObject);
begin
  Zvuk.Checked:=not Zvuk.Checked;
end;

procedure TForm1.ToplistClick(Sender: TObject);
begin
  if hrajem then PauzaClick(Sender);
  TopListForm.ShowModal;
end;

// reakcie na uzivatelove sipky
procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  { Kurzorove sipky      Pohyb zabky
     38                      0
  37    39                 2   3
     40                      1         }
  if hrajem then
    case Key of
      38: Zabka.Pohyb(0);
      40: Zabka.Pohyb(1);
      37: Zabka.Pohyb(2);
      39: Zabka.Pohyb(3);
    end;

end;

// zacatie novej hry (F2, CTRL+N)
procedure TForm1.NovahraClick(Sender: TObject);
begin
  hrajem:=False;
  Timer1.Enabled:=False;
  // obnovenie rychlosti pri zacani hry
  Timer1.Interval:=1300;
  // Resetuj listy
  Form1.ResetujListy;
  // Zmaz listy z plochy (maze sa aj pri TList.Reset)
  Form1.Pozadie(0,0,576,576);
  // vykresli listy
  Form1.VykresliListy;
  // vykresli sa bitmapa (bufferovacia) na obrazovku
  PlochaRepaint(Rect(0,0,576,576));
  // Vytvorenie zabky ked neexistuje
  if (Zabka=NIL) then
    Zabka:=TZaba.Create
  else
    begin
      Zabka.zivoty:=5;
      Zabka.body:=0;
      Zabka.PridajBody(0); // vynulovanie napisu
      Zabka.Reset(False);
    end;
  // Vytvorenie musky, ako nepriatela
  if (Muska=NIL) then
    Muska:=TMucha.Create
  else
    Muska.Reset;

  // zacatie hry
  hrajem:=True;
  Timer1.Enabled:=True;
  // moznost dat pauzu
  Pauza.Enabled:=True;
  Pauza2.Enabled:=True;
end;

// timer, ktory zaistuje, ze sa listy zmensuju, mucha lieta a pod.
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  ZmensiListy;
  PlochaRepaint(Rect(0,0,576,576));
  Application.ProcessMessages;
  Zabka.Kresli;
  Muska.RobNieco;
  Application.ProcessMessages;
  Application.ProcessMessages;
  Application.ProcessMessages;
end;

// ukoncenie hry, zastavenie timeru a odchytavania klaves, vypisanie hlasky
procedure TForm1.KoniecHry;
begin
  Timer1.Enabled:=False;
  hrajem:=False;
  // zrusenie moznosti dat pauzu
  Pauza.Enabled:=False;
  Pauza2.Enabled:=False;
  // zobrazenie napisu konca hry
  // styl pisma
  Plocha.Canvas.Brush.Style := bsClear;
  Plocha.Canvas.Font.Name := 'Arial';
  Plocha.Canvas.Font.Size := 72;
  Plocha.Canvas.Font.Style:= [ fsBold ];
  // napis
  Plocha.Canvas.Font.Color := clBlack;
  Plocha.Canvas.TextOut( 31,131,'Koniec hry' );
  Plocha.Canvas.Font.Color := clWhite;
  Plocha.Canvas.TextOut( 29,129,'Koniec hry' );
  Plocha.Canvas.Font.Color := $04d8ff;
  Plocha.Canvas.TextOut( 30,130,'Koniec hry' );
  // toplist
  TopListForm.Pridaj(lblMeno.Caption,zabka.body);
end;

// Pauza - po neustalom zapinani a vypinani pauzy je interval Timeru zbytocny :-(
procedure TForm1.PauzaClick(Sender: TObject);
begin
  if Pauza.Checked then
    // zrusenie pauzy
    begin
      Pauza.Checked:=False;
      Timer1.Enabled:=True;
      hrajem:=True;
      PlochaRepaint(Rect(0,0,576,576));
      Zabka.Kresli;
    end
  else
    // zapnutie pauzy
    begin
      Pauza.Checked:=True;
      Timer1.Enabled:=False;
      hrajem:=False;
      // zobrazenie napisu PAUZA
      // styl pisma
      Plocha.Canvas.Brush.Style := bsClear;
      Plocha.Canvas.Font.Name := 'Arial';
      Plocha.Canvas.Font.Size := 72;
      Plocha.Canvas.Font.Style:= [ fsBold ];
      // napis
      Plocha.Canvas.Font.Color := clBlack;
      Plocha.Canvas.TextOut( 131,131,'PAUZA' );
      Plocha.Canvas.Font.Color := clWhite;
      Plocha.Canvas.TextOut( 129,129,'PAUZA' );
      Plocha.Canvas.Font.Color := $04d8ff;
      Plocha.Canvas.TextOut( 130,130,'PAUZA' );
      // info
      Plocha.Canvas.Font.Size := 20;
      Plocha.Canvas.Font.Color := clNavy;
      Plocha.Canvas.TextOut( 15,220,'Pokraovanie stlaenm F3 alebo CTRL+P' );
    end;
end;

procedure TForm1.Info1Click(Sender: TObject);
begin
  if hrajem then PauzaClick(Sender);
  Application.CreateForm(TAboutForm, AboutForm);
  AboutForm.ShowModal;
  AboutForm.Destroy;
end;

procedure TForm1.Pomoc2Click(Sender: TObject);
begin
  if hrajem then PauzaClick(Sender);
  Application.CreateForm(TPomocForm, PomocForm);
  PomocForm.ShowModal;
  PomocForm.Destroy;
end;

end.
